using System;
using System.Threading;

namespace FlickeringListview
{

	/// <summary>
	/// Summary description for DataGenerator.
	/// </summary>
	public class DataGenerator
	{
        private Datum[] myData;

		public DataGenerator(Datum[] data)
		{
            myData = data;
		}

        public void start()
        {
            Thread trd = new Thread(new ThreadStart(this.threadTask));
            trd.IsBackground = true;
            trd.Start();
        }

        private void threadTask()
        {
            Random rnd=new Random();

            while(true)
            {
                double newVal = rnd.NextDouble();
                int datumIndex = rnd.Next(myData.Length);
                int subDatumIndex = rnd.Next(myData[datumIndex].Length);

                myData[datumIndex].update(subDatumIndex, myData[datumIndex][subDatumIndex] + newVal - .5d);

                Thread.Sleep(100);
            }
        }
	}
}
